'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BasicHTMLEnvironment = undefined;

var _basichtml = require('basichtml');

var _basichtml2 = _interopRequireDefault(_basichtml);

var _jestEnvironmentNode = require('jest-environment-node');

var _jestEnvironmentNode2 = _interopRequireDefault(_jestEnvironmentNode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//

//

class BasicHTMLEnvironment extends _jestEnvironmentNode2.default {
  constructor(config) {
    super(config);

    const { CustomElementRegistry, Document } = _basichtml2.default;
    const window = this.global;

    Object.assign(window, _basichtml2.default);

    window.customElements = new CustomElementRegistry();
    window.document = new Document(window.customElements);
    window.document = new Document(window.customElements);
    window.window = window;

    // Ensure that the real global env has the document
    global.document = window.document;
  }

  async teardown() {
    await super.teardown();

    this.global.document = null;
    this.global.window = null;

    global.document = null;
  }
}
exports.BasicHTMLEnvironment = BasicHTMLEnvironment;